function calib4 = calib4(y)

global sigma gamma beta taul taus taue beta de ds u up v vp z lambda alpha eta omega rho nu ps phi
calib3 = ones(1,5);

z(1) = 1;
z(2) = 1;
phi = y(1);
omega = y(2);
nu = y(3);
beta = y(4);
%y
v  = @(l) phi*l.^(1+gamma)./(1+gamma);
vp = @(l) phi*l.^gamma;

x0 = .1*ones(1,8);
%load x
%x0 = x;
options = optimset('display', 'off','tolfun', 10^(-20), 'tolX', 10^(-20), 'maxfunevals', 1000000,'maxiter', 1000000);%   
x = fsolve(@systemSSCE, x0, options);
%sum(sum(abs(systemSSCE(x))))

save x x

cs = x(1);
cu = x(2);
Cs = cs*ps;
Cu = cu*(1-ps);
ls = x(3);
lu = x(4);
Ls = z(2)*ls*ps;
Lu = z(1)*lu*(1-ps);
as = x(5);
au = x(6);
As = as*ps;
Au = au*(1-ps);
Ke = x(7);
Ks = x(8);

MP = ycompprime([Ks, Ke, Lu, Ls]);
skillp = z(2)*MP(4)/(z(1)*MP(3));
labor = ls*ps+lu*(1-ps);
Y = ycomp([Ks, Ke, Lu, Ls]);
lshare = (MP(3)*Lu + MP(4)*Ls)/Y;
KY = (Ke+Ks)/Y;

calib4(1) = skillp - 1.8;
calib4(2) = labor - 1/3;
calib4(3) = lshare - 2/3;
calib4(4) = KY - 2.9;
calib4;
