%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%This program finds roots of the system of the FOC in the infinite period
%%%%%Mirrlees problem with complementarity as defined in Krusell et al
%%%%%(2000). Types are permanent. It is based on the code called Reform.m. It also verifies the other IC's.%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
clc
global zu zs pu ps T ke1 ks1 y r beta alpha eta omega rho nu u up v vp de ds G phis


%welfare weights
phis = 1; %on the skilled guy, the unskilled is normalized to 1

%parameters
T = 200; %steady state starts in T
load input

G = input(13);
sigma = input(11);
gamma = input(12);
%gamma = .05

if sigma == 1
   u  = @(c) log(c);
   up = @(c) 1./c;
else
    u  = @(c) c.^(1-sigma)./(1-sigma);
    up = @(c) c.^-sigma;
end

phi =input(1);
%phi = 39.0240


v  = @(l) phi*l.^(1+gamma)./(1+gamma);
vp = @(l) phi*l.^gamma;

de = .124;%GHK
ds = .056;%GHK

ke1 = input(3);	
ks1 = input(4);

%ke1 = 1;	
%ks1 = 1;

beta = input(5);
eta = input(6);
rho = input(7);
alpha = input(8);
omega = input(9);
nu =input(10);

zu =input(2);
%zu = 1;
zs = 1;
%measure of skilled agents
pratio = .778;
ps = pratio/(pratio+1);
pu = 1-ps;

%initial guess 
%x0 = .1*ones(7*T+6,1);
%load x;
%x0 = x;
load xbench
x0 = xbench;

tic

options = optimset('display', 'iter', 'tolfun', 10^(-20), 'tolX', 10^(-20), 'maxfunevals', 1000000, 'maxiter', 50); 
%options = optimset('display', 'iter', 'tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000, 'NonlEqnAlgorithm', 'gn'); 
%options = optimset('display', 'iter', 'tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000, 'NonlEqnAlgorithm', 'lm'); 
%options = optimset('display', 'iter', 'tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000, 'largescale', 'on'); 
x = fsolve(@SystemDynamic, x0, options);
toc
SystemDynamic(x);
if abs(sum(SystemDynamic(x).^2)) > 10^-6
    display 'The first system was not solved!'
end
%xS1G05 = x;
%save xS1G05 xS1G05
save x x


cs = x(1:T+1);
cu = x(T+2: 2*(T+1));
ls = x(2*T+3: 3*(T+1));
lu = x(3*T+4: 4*(T+1));
kspol =  x(4*(T+1)+ 1: 4*(T+1)+T);
kepol =  x(4*(T+1)+ T + 1: 4*(T+1)+2*T);
ks = [ks1; kspol];
ke = [ke1; kepol];
lambda = x(4*(T+1)+2*T+ 1:5*(T+1)+2*T);
mu = x(5*(T+1)+2*T+1);

%aggregates
Lu = pu*zu*lu;
Ls = ps*zs*ls;
Cu = pu*cu;
Cs = ps*cs;

MP = ycompprime([ks, ke, Lu, Ls]);
rs = MP(:,1);
re = MP(:,2);
wu = MP(:,3)*zu;
ws = MP(:,4)*zs;

Re = re + 1- de;
Rs = rs + 1- ds;

der = ycompdprime([ke, lu, ls]);

%Cs + Cu  + [ks(2:T+1); ks(T+1)] + [ke(2:T+1); ke(T+1)] - (1-ds)*ks - (1-de)*ke- ycomp([ks, ke, Lu, Ls])
cons = (ps/pu*(pu - mu)/(ps + mu))^(1/sigma);
cu- cs*cons;

Y = ycomp([ks, ke, Lu, Ls]);


lambda;


EEcheck1 = - lambda(T)  + beta*lambda(T+1).*(rs(T+1) + 1-ds);
EEcheck2 = - lambda(T) +  beta*lambda(T+1).*(re(T+1) + 1-de) + ...
    + mu*beta*vp(lu(T+1).*wu(T+1)./ws(T+1)).*der(T+1,1);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Here I will compute the wedges.%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%capital return wedge
capitalw = (re + 1 - de)./(rs + 1 - ds) - 1;
%intra wedges unskilled
intrau = 1-vp(lu)./(up(cu).*wu);
%intra wedges skilled
intras = 1-vp(ls)./(up(cs).*ws);
%inter wedges for structure capital
interksu = 1- up(cu(1:T))./(beta*(rs(2:T+1)+1-ds).*up(cu(2:T+1)));
interksu(T+1) = 1 - 1/(beta*(rs(T+1)+1-ds));
interkss = 1- up(cs(1:T))./(beta*(rs(2:T+1)+1-ds).*up(cs(2:T+1)));
interkss(T+1) = 1 - 1/(beta*(rs(T+1)+1-ds));
%inter wedges for equipment capital
interkeu = 1- up(cu(1:T))./(beta*(re(2:T+1)+1-de).*up(cu(2:T+1)));
interkeu(T+1) = 1 - 1/(beta*(re(T+1)+1-de));
interkes = 1- up(cs(1:T))./(beta*(re(2:T+1)+1-de).*up(cs(2:T+1)));
interkes(T+1) = 1 - 1/(beta*(re(T+1)+1-de));

%alternative inter wedges
interksualt = 1 - (up(cu(1:T))./(beta*up(cu(2:T+1))) - 1)./(rs(2:T+1) - ds);
interksualt(T+1) = 1-(1/beta-1)/(rs(T+1)-ds);
interkssalt = 1 - (up(cs(1:T))./(beta*up(cs(2:T+1))) - 1)./(rs(2:T+1) - ds);
interkssalt(T+1) = 1-(1/beta-1)/(rs(T+1)-ds);
interkeualt = 1 - (up(cu(1:T))./(beta*up(cu(2:T+1))) - 1)./(re(2:T+1) - de);
interkeualt(T+1) = 1-(1/beta-1)/(re(T+1)-de);
interkesalt = 1 - (up(cs(1:T))./(beta*up(cs(2:T+1))) - 1)./(re(2:T+1) - de);
interkesalt(T+1) = 1-(1/beta-1)/(re(T+1)-de);

%returns
%([re(2:T+1); re(T+1)] - de).*(1-interkesalt(1:T+1)) - ([rs(2:T+1); rs(T+1)] - ds).*(1-interkssalt(1:T+1))
%([re(2:T+1); re(T+1)] - de).*(1-interkeualt(1:T+1)) - ([rs(2:T+1); rs(T+1)] - ds).*(1-interksualt(1:T+1))

%determining overall labor taxes and asset levels in implemented SS
%[(([rs(2:T+1); rs(T+1)] - ds).*interkssalt(1:T+1)).*ks,(([rs(2:T+1); rs(T+1)] - ds).*interksualt(1:T+1)).*ks]
%[(([re(2:T+1); re(T+1)] - de).*interkesalt(1:T+1)).*ke,(([re(2:T+1); re(T+1)] - de).*interkeualt(1:T+1)).*ke]
ctax = ((([re(2:T+1); re(T+1)] - de).*interkesalt(1:T+1)).*ke + (([rs(2:T+1); rs(T+1)] - ds).*interkssalt(1:T+1)).*ks);
ltax = (G - ctax)/G;
ctax = ctax/G;

corptax = ((1-(1-interkssalt)/.85).*(MP(:,1) - ds).*ks + (1-(1-interkesalt)/.85).*(MP(:,2) - de).*ke)./(ctax*G);

%share in asset holdings of the skilled in the data
%wratio = 2.68;
%wratio = 1;
%lambdaA = wratio*ps/(wratio*ps+pu);
%As = lambdaA*(ks+ke);
%as = As/ps;
%Au = (ks+ke)-As;
%au = Au/pu;
%average taxes
%ats = (ws.*ls - cs + ([rs(2:T+1); rs(T+1)] - ds).*(1-interkssalt(1:T+1)).*as)./(ws.*ls);
%atu = (wu.*lu - cu + ([rs(2:T+1); rs(T+1)] - ds).*(1-interkssalt(1:T+1)).*au)./(wu.*lu);
ats = (ws.*ls - cs)./(ws.*ls);
atu = (wu.*lu - cu)./(wu.*lu);


%define beta^t in vector form
betatemp = cumprod([1;beta*ones(T,1)]);
betavec = [betatemp(1:T); betatemp(T+1)/(1-beta)];
%compute welfare
ucs = betavec'*u(cs);
ucu = betavec'*u(cu);
vls = betavec'*v(ls);
vlu = betavec'*v(lu);
values = ucs - vls;
valueu = ucu - vlu;
value = phis*ps*(ucs-vls) + pu*(ucu-vlu);
%Value =  betavec'*(ps*(u(cs) - v(ls)) +pu*(u(cu) - v(lu)))
%check the other IC
ICu = betavec'*(u(cu) - v(lu) - u(cs) + v(ls.*ws./wu));
mu;
if ICu < 0
    display 'ICu is violated'
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Other output.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
skillp = ws./wu;
earp = ws.*ls./(wu.*lu);
lshare = (MP(:,3).*Lu + MP(:,4).*Ls)./Y;


 output = [beta, alpha, eta, rho omega, nu, ucs, ucu, vls, vlu, values, valueu, value, phi, sigma, gamma, ke(T+1), ks(T+1), Y(T+1),...
    (ke(T+1)+ks(T+1))/Y(T+1), cs(T+1), cu(T+1), ls(T+1), lu(T+1), ...
     ls(T+1)*ps + lu(T+1)*pu, ws(T+1), wu(T+1), skillp(T+1), earp(T+1), lshare(T+1), ...
     G, G/Y(T+1),NaN,NaN,ats(T+1),atu(T+1),ltax(T+1),ctax(T+1), corptax(T+1), ...
     capitalw(T+1), intrau(T+1), intras(T+1), interkeu(T+1),interksu(T+1), interkeualt(T+1), interksualt(T+1),...
     capitalw(1), intrau(1), intras(1), interkeu(1), interksu(1), interkeualt(1), interksualt(1)]';

%save allHeS4G05