function ycompprime = ycompprime(x)

global alpha eta omega rho nu
%vector of marginal products wrt ks, ke, Lu, Ls, aggregates

ks = x(:,1);
ke = x(:,2);
lu = x(:,3);
ls = x(:,4);


%define brackets and parentheses
brack = (omega*ke.^rho + (1-omega)*ls.^rho);
parent = ( (1-nu)*lu.^eta + nu*brack.^(eta/rho));
term = ks.^alpha* ((1-alpha)/eta).*parent.^((1-alpha)/eta-1);

ycompprime(:,1) = alpha*ks.^(alpha-1).* parent.^((1-alpha)/eta);
ycompprime(:,2) = term*nu*eta/rho.*brack.^(eta/rho-1)*omega*rho.*ke.^(rho-1);
ycompprime(:,3) = term*(1-nu)*eta.*lu.^(eta-1);
ycompprime(:,4) = term*nu*eta/rho.*brack.^(eta/rho-1)*(1-omega)*rho.*ls.^(rho-1);